package rmidemo;



import java.sql.*;
import java.util.Vector;


public class DataModelImpl extends javax.swing.table.AbstractTableModel 
implements DataModel {

   private int last_row_count;
   private long last_update_time;
   private java.sql.Connection con;
   private String filter;

   protected Vector<String> row_keys = new Vector<String>();
   protected Object[] last_row = new Object[3];
   static final String[] colnames = { "title", "body", "update_time" };

   public synchronized void setFilter(String new_filter) {
      filter = new_filter;
      try {
	 if (refreshQuery()) 
	    fireTableDataChanged();
      } catch (SQLException e) {
	 throw new RuntimeException(e);
      }
   }

   protected Connection getCon() throws SQLException {
      if (con==null) {
	 try {
	    Class.forName("com.mysql.jdbc.Driver");
	 } catch (ClassNotFoundException e) {
	    throw new RuntimeException(e);
	 }
	 con = DriverManager.getConnection("jdbc:mysql://localhost/test",
					   "app-data","");
      }
      return con;
   }
   protected boolean refreshQuery() throws SQLException {
      getCon();
      ResultSet rs = con.createStatement()
	 .executeQuery("SELECT COUNT(*),MAX(update_time) FROM rmiDemoTable "+
	               ((filter==null||filter.trim().equals(""))
			?"":"WHERE "+filter));
      rs.next();
      if (rs.getInt(1) != last_row_count ||
	  rs.getTimestamp(2) == null ||
	  rs.getTimestamp(2).getTime() != last_update_time) {
	 con.createStatement().executeUpdate("LOCK TABLES rmiDemoTable READ");
	 row_keys.clear();
	 rs = con.createStatement()
	    .executeQuery("SELECT title FROM rmiDemoTable "+
			  ((filter==null)?""
			   :"WHERE "+filter));
	 while (rs.next())
	    row_keys.add(rs.getString(1));

	 rs = con.createStatement()
	    .executeQuery("SELECT COUNT(*),MAX(update_time) "+
			  "FROM rmiDemoTable");
	 rs.next();
	 last_row_count = rs.getInt(1);
	 if (last_row_count==0) last_update_time=0;
	 else
	    last_update_time = rs.getTimestamp(2).getTime();
	 con.createStatement().executeUpdate("UNLOCK TABLES");
	 return true;
      }
      return false;
   }

   public String getColumnName(int col) { return colnames[col]; }

   public synchronized int getRowCount() {
      try {
	 refreshQuery();
	 return row_keys.size() + 1;
      } catch (SQLException e) {
	 throw new RuntimeException(e);
      }
   }
   public synchronized int getColumnCount() { return 3; }
   public synchronized Object getValueAt(int row, int column) {
      if (row==row_keys.size()) 
	 return last_row[column]; 
      if (column==0)
	 return row_keys.get(row);
      try {
	 getCon();
	 PreparedStatement pst 
	    = con.prepareStatement("SELECT "+colnames[column]+" "+
				   "FROM rmiDemoTable WHERE title=? ");
	 pst.setString(1,row_keys.get(row));
	 ResultSet rs = pst.executeQuery();
	 if (!rs.next()) return null;
	 switch (column) {
	 case 1: return rs.getString(1);
	 case 2: return rs.getTimestamp(1);
	 default: return null;
	 }
      } catch (SQLException e) {
	 throw new RuntimeException(e);
      }
   }   
   
   public boolean isCellEditable(int row, int column) {
      return (column!=2) ;
   }

   public void setValueAt(Object o, int r, int c) {
      try {
	 getCon();
	 PreparedStatement pst; 
	 if (r==row_keys.size()) {
	    last_row[c] = o;
	    if (last_row[0]!=null) {
	       pst = con.prepareStatement("INSERT INTO  rmiDemoTable "+
					  "  (title,body) VALUES (?,?)");
	       pst.setString(1,last_row[0].toString());
	       pst.setString(2,last_row[1]==null?null:
			       last_row[1].toString());
	       pst.executeUpdate();
	       row_keys.add(last_row[0].toString());
	       last_row = new Object[3];
	       fireTableRowsInserted(row_keys.size()-1,row_keys.size()-1);
	    }
	 } else {
	    pst = con.prepareStatement("UPDATE rmiDemoTable "+
				      "SET "+colnames[c]+"=? "+
				      "WHERE title=? ");
	    pst.setString(1,o.toString());
	    pst.setString(2,row_keys.get(r));
	    pst.executeUpdate();
	    if (c==0) row_keys.set(r,o.toString());
	    fireTableCellUpdated(r,c);
	 }
      } catch (SQLException e) {
	 throw new RuntimeException(e);
      }
   }


   public synchronized void deleteRow(int row) {
      try {
	 getCon();
	 PreparedStatement pst 
	    = con.prepareStatement("DELETE FROM rmiDemoTable "+
				   "WHERE title=? ");
	 pst.setString(1,row_keys.get(row));
	 pst.executeUpdate();
	 row_keys.remove(row);
	 fireTableRowsDeleted(row,row);
      } catch (SQLException e) {
	 throw new RuntimeException(e);
      }
   }
}
