package rmidemo;

import java.rmi.RemoteException;
import java.rmi.Remote;
import javax.swing.event.TableModelListener;

public class DataModelProxy implements Remote,java.io.Serializable {
   
   DataModel model;
   DataModelProxy(DataModel model) { this.model=model; }

   public  boolean isCellEditable(int i, int j) throws RemoteException {
      try {
	 return model.isCellEditable(i,j);
      } catch (RuntimeException e) {
	 throw new RemoteException("Error on server",e);
      }
   }
   public  int getColumnCount() throws RemoteException { 
      try { 
	 return model.getColumnCount();
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e);
      }
   }
   public  int getRowCount() throws RemoteException { 
      try { 
	 return model.getRowCount();
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  java.lang.Class getColumnClass(int i) throws RemoteException { 
      try { 
	 return model.getColumnClass(i);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  java.lang.Object getValueAt(int i, int j) throws RemoteException { 
      try {
	 return model.getValueAt(i,j);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  java.lang.String getColumnName(int i) throws RemoteException { 
      try { 
	 return model.getColumnName(i);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  void addTableModelListener(TableModelListener l) throws RemoteException { 
      try { 
	 model.addTableModelListener(l);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  void deleteRow(int i) throws RemoteException { 
      try {
	 model.deleteRow(i);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  void removeTableModelListener(TableModelListener l) throws RemoteException { 
      try {
	 model.removeTableModelListener(l);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  void setFilter(java.lang.String s) throws RemoteException { 
      try {
	 model.setFilter(s);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }
   public  void setValueAt(java.lang.Object o, int i, int j) throws RemoteException { 
      try {
	 model.setValueAt(o,i,j);
      } catch (RuntimeException e) { 
	 throw new RemoteException("Error on server",e); 
      } 
   }


   private class LocalPart implements DataModel,java.io.Serializable {

       public boolean isCellEditable(int i, int j) { 
	  try { 
	     return DataModelProxy.this.isCellEditable(i,j);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public int getColumnCount() { 
	  try { return DataModelProxy.this.getColumnCount();  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public int getRowCount() { 
	  try { 
	     return DataModelProxy.this.getRowCount();  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public java.lang.Class getColumnClass(int i) { 
	  try { 
	     return DataModelProxy.this.getColumnClass(i);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public java.lang.Object getValueAt(int i, int j) { 
	  try { 
	     return DataModelProxy.this.getValueAt(i,j);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public java.lang.String getColumnName(int i) { 
	  try { 
	     return DataModelProxy.this.getColumnName(i);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public void addTableModelListener(TableModelListener l) { 
	  try { 
	     DataModelProxy.this.addTableModelListener(l);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public void deleteRow(int i) { try { 
	     DataModelProxy.this.deleteRow(i);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public void removeTableModelListener(TableModelListener l) { 
	  try { 
	     DataModelProxy.this.removeTableModelListener(l);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public void setFilter(java.lang.String s) { 
	  try { 
	     DataModelProxy.this.setFilter(s);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }
       public void setValueAt(java.lang.Object o, int i, int j) { 
	  try { 
	     DataModelProxy.this.setValueAt(o,i,j);  
	  } catch (RemoteException e) { throw new RuntimeException(e); } }

   }

   public DataModel getLocalPart() { 
      return new LocalPart(); 
   } 
}
